// przerobione z easyai

#include <iostream.h>

#include "Options.H"
#include "GameStateModule.H"
#include "ShutDown.H"
#include "SDLinit.H"
#include "Game.H"

#include "AIGUI.H"
#include "SampleEventHandler.H"
#include "AIState.H"
#include "Coordinator.H"

static char *VERSION = "sampleai v0.1";

using namespace std;

void add_options() {
  Options opt("A1");
  opt.put("-go_disp", "2d debug display");
  opt.put("-handicap", 0, "number of unused marines");
}

int main(int argc, char **argv) {
  signals_shut_down(true);  
  add_options();
  GameStateModule::Options::add();
  Game::Options::add();
  AIGUI::add_options();
  if (Options::process(argc, argv, cerr, VERSION)) exit(20);
  SDLinit::network_init();
  GameStateModule::Options gsmo;
  GameStateModule gsm(gsmo);
  state.initialized = false;
  state.gsm = &gsm;
  SampleEventHandler sev;
  gsm.add_handler(&sev);
  if (!gsm.connect()) ERR("connection problems");
  sint4 hcap;
  Options::get("-handicap", hcap);
  state.hcap = hcap;
  bool go_disp;
  Options::get("-go_disp", go_disp);
  state.gui = NULL;
  if (go_disp)
    state.gui = new AIGUI();
  while (!state.quit) if (!state.gsm->recv_view()) SDL_Delay(1);
  cout << "game over.\n";
  if (state.myMarines->size > 0) {
    cout << ((state.playerId) ? "red" : "blue") << " won (" << state.myMarines->size << " units left)" << endl;
  } else {
    cout << ((state.playerId) ? "blue" : "red") << " won (" << state.oppMarines->size << " units left)" << endl;
  }
  return 0;
}
