#ifndef AIGUI_H
#define AIGUI_H

#include "GUI.H"

#include "Common.H"

#define WWidth 1012
#define WHeight 675

#define ClWhite RGB(255, 255, 255)
#define ClGray RGB(128, 128, 128)
#define ClBlack RGB(0, 0, 0)
#define ClMaroon RGB(128, 0, 0)
#define ClNavy RGB(0, 0, 128)
#define ClRed RGB(255, 0, 0)
#define ClBlue RGB(0, 0, 255)
#define ClPink RGB(200, 50, 50)

#define S_ARR_MAX 120

class AIObject;

class AIGUI : public GUI {
    private:
	GfxView2 gv2;
	void draw_digth(const GfxView2& gv, int x, int y, int w, int h, int n, const RGB& c);
	void draw_gamestat();
    public:
	static void add_options();
	AIGUI();
	~AIGUI() {};
	void display(const GameObj* gob1=0, const GameObj* gob2=0);
	void draw_int(int x, int y, int w0, int h, int n, const RGB& c);
	void line(int x1, int y1, int x2, int y2, const RGB& c);
	void circle(int x, int y, int r, const RGB& c, bool filled=false);
	void line(TPoint p1, TPoint p2, const RGB& c);
	void circle(TPoint s, int r, const RGB& c, bool filled=false);
	void rect(int x, int y, int w, int h, const RGB& fc);
	void filledRect(int x, int y, int w, int h, const RGB& bc);
};

class Unit_gui : public GUI {
    public:
	AIObject* aiob;
	int s_arr[S_ARR_MAX][3];
	Unit_gui() {};
	Unit_gui(AIObject* a);
	~Unit_gui() {};
	void show_dmg(AIGUI* gui, int n);
};

#endif
