#ifndef AIObject_H
#define AIObject_H

#include "Common.H"
#include "GameObj.H"
#include "AIGUI.H"

class AIObject {
    public:
	GameObj* gob;
	int id;
	bool dead;
	int owner;
	TPoint pos;
	AIObject(GameObj* gob);
	Unit_gui* ug;
	virtual ~AIObject() {};
	virtual bool is_ally() {return false;};
	virtual bool is_enemy() {return false;};
	virtual void refresh();
	virtual void redraw(AIGUI* gui);
	bool is_moving();
	float dist_to(AIObject* aiob);
};

class Asheep : public AIObject {
    public:
	Asheep(GameObj* gob);
	void redraw(AIGUI* gui);
};

class AMarine : public AIObject {
    public:
	int range;
	int hp;
	int prev_hp;
	AMarine(GameObj* gob);
	bool is_enemy() {return true;};
	void refresh();
	void redraw(AIGUI* gui);
	AMarine* nearby_enemy();
};

class MyMarine : public AMarine {
    private:
	bool go_attack;
	int prev_dist;
	int bumps;
	int tot_bumps;
	bool around;
	TPoint dest;
	AIObject* target;
	bool in_move;
	bool agressive;
	int cooldown;
    public:
	int max_bumps;			// po ilu kolizjach sie zatrzymuje
	bool idle;
	AMarine* direct_target;
	MyMarine(GameObj* gob);
	bool is_ally() {return true;};
	void refresh();			// aktualizuje stan jednostki
	void redraw(AIGUI* gui);
	void low_stop();
	void low_move(TPoint pos);
	void low_attack(AMarine* aiob);
	void update();			// aktualizuje niskopoziomowe rozkazy
					// (np. po kolizji, przypomina jednostce, co miala zrobic)
	void stop();			// przerywa wykonywanie bierzacej akcji (ilde:=true)
	void moveTo(TPoint p);		// idzie do punktu p (omijajac przeszkody)
	void follow(AIObject* aiob);	// idzie w strone danej jednostki (samonaprowadzajace)
	void attack(AMarine* aiob);	// idzie zaatakowac dana jednostke
	void holdPosition();		// zatrzymuje sie i czeka, za przeciwnik podejdzie
	void autoAttack(TPoint p);	// idze w strone punktu p i atakuje wszystkich po drodze
	void autoAttack(AMarine* aiob);	// jw. ale idzie w strone podanej jednostki (follow)
};

#endif
