#include <math.h>

#include "Common.H"

TPoint::TPoint() {
    x = y = -1;
}

TPoint::TPoint(int a, int b) {
    x = a;
    y = b;
}

TPoint operator+(TPoint p1, TPoint p2) {
    return TPoint(p1.x+p2.x, p1.y+p2.y);
}

bool operator==(TPoint p1, TPoint p2) {
    return (p1.x == p2.x) && (p1.y == p2.y);
}

float sqr(float x) {
    return x * x;
}

int dist(TPoint p1, TPoint p2) {
    return (int)(sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y)));
}
