#include <iostream.h>

#include "GameChanges.H"
#include "GameObj.H"

#include "AIState.H"
#include "AIObject.H"
#include "UnitGroup.H"

#include "Game.H"

#define chk_gob() \
    gob = (*it)->get_GameObj();\
    if (!gob) continue;\
    if (!gob->sod.in_game) continue;

void InitAI() {
    cout << "***************** I N I T I A L I Z I N G . . . *******************" << endl;
    state.initialized = true;
    state.last_aiob_id = 0;
    state.quit = false;
    state.SHEEP_SIZE = -1;
    state.MARINE_SIZE = -1;
    int tilep = state.gsm->get_game().get_tile_points();
    state.MAP_WIDTH = state.gsm->get_game().get_map().get_width() * tilep;
    state.MAP_HEIGHT = state.gsm->get_game().get_map().get_height() * tilep;
    state.gameTime = 0;
    state.playerId = state.gsm->get_game().get_client_player();
    state.allUnits = new UnitGroup();
    state.sheeps = new UnitGroup();
    state.myMarines = new UnitGroup();
    state.oppMarines = new UnitGroup();
    state.curr_target = NULL;
    state.AIstage = 0;
    if (state.gui)
	cout << "2d gui enabled" << endl;
}

void AddUnit(GameObj* gob) {
    AIObject* aiob;
    int o = *gob->sod.owner;
    if (o == 2) {
	aiob = new Asheep(gob);
	state.sheeps->AddUnit(aiob);
    } else {
	if (o == state.playerId) {
	    aiob = new MyMarine(gob);
	    state.myMarines->AddUnit(aiob);
	} else {
	    aiob = new AMarine(gob);
	    state.oppMarines->AddUnit(aiob);
	}
    }
    state.allUnits->AddUnit(aiob);
}

void RemoveUnit(GameObj* gob) {
    state.allUnits->RemoveUnit(gob);
    int o = *gob->sod.owner;
    if (o == 2) {
	state.sheeps->RemoveUnit(gob);
    } else {
	if (o == state.playerId) {
	    state.myMarines->RemoveUnit(gob);
	} else {
	    state.oppMarines->RemoveUnit(gob);
	}
    }
}

void UpdateWorld() {
    state.gameTime = state.gsm->get_game().tick(); //++
    cout << "---------------------------------- Frame nr " << state.gameTime << " ----------------------------------\n";
    GameObj* gob;
    const GameChanges* changes = &state.gsm->get_changes();
    FORALL(changes->new_objs, it) {
	chk_gob();
	if ((state.SHEEP_SIZE == -1) && (*gob->sod.owner == 2)) {
	    state.SHEEP_SIZE = *gob->sod.radius;
	    cout << "sheep radius: " << state.SHEEP_SIZE << endl;
	}
	if ((state.MARINE_SIZE == -1) && (*gob->sod.owner < 2)) {
	    state.MARINE_SIZE = *gob->sod.radius;
	    state.MARINE_COOLDOWN = gob->component("weapon")->get_int("cooldown");
	    state.MARINE_MAX_HP = gob->get_int("hp");
	    cout << "marine radius: " << state.MARINE_SIZE << endl;
	}
	if (state.hcap && (*gob->sod.owner == state.playerId)) {
	    state.hcap--;
	    Asheep* sheep = new Asheep(gob);
	    state.sheeps->AddUnit(sheep);//?
	    continue;
	}
	AddUnit(gob);
    }
    FORALL(changes->vanished_objs, it) {
	chk_gob();
	RemoveUnit(gob);
    }
    FORALL(changes->dead_objs, it) {
	chk_gob();
	RemoveUnit(gob);
    }
    FORALL(state.allUnits->v, it)
	(*it)->refresh();
}

void ComputeActions0() { // stata wersja
    state.myMarines->autoAttack((AMarine*)state.oppMarines->any());
    state.myMarines->update();
}

void ComputeActions() {
   if (state.AIstage == 0) {						// inicjalizacja
	state.f1 = new Formation();
	FORALL(state.myMarines->v, it)
	    state.f1->AddUnit(*it);
	for (int i=0; i<MAX_MARINES; i++)
	    state.f1->shape[i] = TPoint((i%2)*40-20, (i/2-12)*18);
	state.f1->init(state.myMarines->middle());
	state.AIstage = 1;
    } else if (state.AIstage == 1) {					// tworzenie formacji
	if ((state.f1->busy() < 3) || (state.f1->underAttack()))
	    state.AIstage = 2;
    } else if (state.AIstage == 2) {					// pelny atak
	state.f1->autoAttack(state.oppMarines->middle());
	if (dist(state.f1->middle(), state.oppMarines->middle()) < 30)
	    state.AIstage = 3;
    } else {								// rozwalanie niedobitkow
	if (!state.curr_target || state.curr_target->dead)
	    state.curr_target = (AMarine*)state.oppMarines->any();
	state.f1->autoAttack(state.curr_target);
    }
    cout << "### stage " << state.AIstage << endl;
    state.f1->update();
}
