#include <iostream.h>

#include "AIState.H"
#include "AIObject.H"
#include "UnitGroup.H"

UnitGroup::UnitGroup() {
    size = 0;
}

void UnitGroup::AddUnit(AIObject* aiob) {
    cout << "addUnit: " << aiob->gob->bp_name() << " (" << *aiob->gob->sod.owner << ")\n";
    v.push_back(aiob);
    size = v.size();
}

void UnitGroup::RemoveUnit(GameObj* gob) {
//    cout << "remove\n";
    FORALL(v, it)
	if ((*it)->gob == gob) {
//	    cout << "erase\n";
	    (*it)->dead = true;
	    v.erase(it);
	    size = v.size();
	    return;
	}
    cerr << "BLAD: nie znaleziono obiektu w UnitGroup::RemoveUnit\n";
}

AIObject* UnitGroup::any() {
    return v[rand() % size];
}

int UnitGroup::busy() {
    int n = 0;
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	if (!m->idle)
	    n++;
    }
    return n;
}

void UnitGroup::update() {
    FORALL(v, it)
	if ((*it)->dead)
	    RemoveUnit((*it)->gob);
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->update();
    }
}

void UnitGroup::stop() {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->stop();
    }
}

void UnitGroup::moveTo(TPoint p) {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->moveTo(p);
    }
}

void UnitGroup::attack(AMarine* aiob) {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->attack(aiob);
    }
}

void UnitGroup::follow(AIObject* aiob) {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->follow(aiob);
    }
}

void UnitGroup::holdPosition() {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->holdPosition();
    }
}

void UnitGroup::autoAttack(TPoint p) {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->autoAttack(p);
    }
}

void UnitGroup::autoAttack(AMarine* aiob) {
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	m->autoAttack(aiob);
    }
}

TPoint UnitGroup::middle() {
    int sx = 0;
    int sy = 0;
    FORALL(v, it) {
	sx += (*it)->pos.x;
	sy += (*it)->pos.y;
    }
    return TPoint(sx / size, sy / size);
}

int UnitGroup::underAttack() {
    int n = 0;
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	if (m->hp != m->prev_hp)
	    n++;
    }
    return n;
}

int UnitGroup::life() {
    int l = 0;
    FORALL(v, it) {
	MyMarine* m = (MyMarine*)*it;
	l += m->hp;
    }
    return l;
}
