#include <math.h>
#include <iostream.h>

#include "Common.H"

TPoint::TPoint() {
    x = y = -1;
}

TPoint::TPoint(float a, float b) {
    x = a;
    y = b;
}

TPoint operator+(TPoint p1, TPoint p2) {
    return TPoint(p1.x+p2.x, p1.y+p2.y);
}

TPoint operator-(TPoint p1, TPoint p2) {
    return TPoint(p1.x-p2.x, p1.y-p2.y);
}

TPoint operator*(TPoint p1, float mul) {
    return TPoint((int)(p1.x*mul), (int)(p1.y*mul));
}

TPoint operator/(TPoint p1, float div) {
    if (div == 0)
	return nowhere;
    return p1*(1/div);
}

bool operator==(TPoint p1, TPoint p2) {
    return (p1.x == p2.x) && (p1.y == p2.y);
}

bool operator!=(TPoint p1, TPoint p2) {
    return (p1.x != p2.x) || (p1.y != p2.y);
}

float sqr(float x) {
    return x * x;
}

int dist(TPoint p1, TPoint p2) {
    return (int)(sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y)));
}

float dist_f(TPoint p1, TPoint p2) {
    return (sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y)));
}
