#ifndef Common_H
#define Common_H

#include <iostream>

#include "TPoint.H"

#define c_debug cout
#define c_info cerr
#define c_notice cerr
#define c_warning cerr
#define c_error cerr

#define mapW state.MAP_WIDTH
#define mapH state.MAP_HEIGHT
#define MAX(a, b) ((a > b) ? a : b)
#define MIN(a, b) ((a < b) ? a : b)
#define ABS(x) ((x > 0) ? (x) : -(x))
#define sqr(x) ((x)*(x))
#define PI() 3.14
#define RC2D(x, y, maxX, maxY) ((x<0) || (x>=maxX) || (y<0) || (y>=maxY))
#define ASSERT(c, m) if (!(c)) ERR(m)
#define RCHK(i, r) if ((i<0) || (i>=r)) ERR("range check error")
#define NOTNULL(x) if (x == NULL) ERR("null pointer error")
#define DELETE(x) if (x != NULL) delete x; x=NULL
#define DRAWLINE if (state.gui) state.gui->line
#define DRAWCIRCLE if (state.gui) state.gui->circle
#define AI_GUI if (state.gui) state.gui
#define NODEPOS(n) state.map->nodePos(n)
#define NODEAT(p) state.map->nodeAt(p)
#define ROUND(p) state.map->round(p)
#define NCNT state.map->N_CNT
#define NARR state.map->N_ARR

#define MAXINT			2000000000
#define HP_HISTORY_LENGTH	8
#define MAX_UNITS		200
#define SMOKE_LENGTH		120
#define MAX_NODES		100000
#define MAX_BOUNDARIES		10000
#define MAX_PATH_LENGTH		1000
#define MAX_WIDTH		2000
#define MAX_HEIGHT		2000
#define MIN_BDIST		8
#define MAX_ISLAND_SIZE		40
#define SHOW_UNIT_STATE		true
#define MAX_MAP_DIST		2000

using namespace std;

float dist(TPoint p1, TPoint p2);
float angle(TPoint p1, TPoint p2);
TPoint angle_r(TPoint p, int a, int r);
TPoint angle_f(TPoint p, float a, float r);
TPoint halfWay(TPoint p1, TPoint p2, float d);
TPoint halfWayPX(TPoint p1, TPoint p2, int px);
bool canSee(TPoint p1, TPoint p1);

#endif
