#ifndef Graph_H
#define Graph_H

#include <vector>

#include "Common.H"
#include "TPoint.H"
#include "AIGUI.H"
#include "GraphShape.H"

using namespace std;

class Graph : public GraphShape {
    private:
	int kol[MAX_NODES];		// queue in BFS
    public:
	bool boundary[MAX_NODES];	// map edges
	bool walls[MAX_NODES];		// map walls
	bool blocked[MAX_NODES];	// nodes blocked by procedure calling BFS
	bool used[MAX_NODES];		// visited (and initial) nodes in BFS
	int dist[MAX_NODES];		// distance from initial nodes
	Graph();
	~Graph() {};
	TPoint round(TPoint p);		// position of nearest node from point p
	void clearBFS();		// XXX po co to?
	void addBoundaries();		// initialize boundaries in graph
	    // maxd -- max. depth; set blocked[] befor calling BFS
	int BFS(vector<int> start, int maxd, bool reversed = false);
	int BFS(int start, int maxd);
	int nearbyOk(int node);		// nearby node that is walkable (not blocked nor wall)
};

class Path {	// XXX po co?
    public:
	Graph* graph;
	int length;
	int nodes[MAX_PATH_LENGTH];
	Path() {};
	Path(Graph* g, int fromp, int top);
	~Path() {};
	void display(const RGB& c);
};

#endif
