#include <math.h>

#include "TPoint.H"
#include "AIState.H"
#include "AIGUI.H"
#include "Common.H"

float dist(TPoint p1, TPoint p2) {
    return sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
}

float angle(TPoint p1, TPoint p2) {
    float dx = p2.x-p1.x;
    float dy = p2.y-p1.y;
    float a = atan(dy / (dx + ((dx == 0) ? 0.001 : 0)));
    float r = a / (2*PI()) * 32 + 48;
    if (dx < 0)
	r += 16;
    while (r >= 32)
	r -= 32;
    return r;
}

TPoint angle_f(TPoint p, float a, float r) {
    while (a >= 32)
	a -= 32;
    float a1 = (a - 16) * 2 * PI() / 32;
    float x = p.x + r * cos(a1);
    float y = p.y + r * sin(a1);
    return TPoint(x, y);
}

TPoint angle_r(TPoint p, int a, int r) {
    return angle_f(p, (float)a, (float)r);
}

TPoint halfWay(TPoint p1, TPoint p2, float d) {
    return p1 + (p2 - p1) * d;
}

TPoint halfWayPX(TPoint p1, TPoint p2, int px) {
    float d = dist(p1, p2);
    if (d <= px)
	return p2;
    return halfWay(p1, p2, px / d);
}

bool canSee(TPoint p1, TPoint p2) {
    ASSERT((p1 != nowhere) && (p2 != nowhere), "canSee");
    int d = (int)dist(p1, p2);
    bool ok = true;
    for (int i=0; i<d; i+=2) {
	TPoint m = halfWay(p1, p2, (float)i/float(d));
	if (state.accessible[(int)m.x][(int)m.y]) {
	    if (!ok)
		return false;
	} else {
	    ok = false;
	}
    }
    return true;
}
