#include "TPoint.H"
#include "AIState.H"
#include "Hardware.H"
#include "UnitGroup.H"
#include "Coordinator1.H"

using namespace std;

void aiInit1() {
    FOREACH(state.minerals, m1)
	FOREACH(state.minerals, m2)
	    if (m1 != m2) {
		int d = (int)dist(m1->hardware->pos, m2->hardware->pos);
		if (d < 60)
		    for (int i=0; i<d; i++) {
			TPoint p = halfWayPX(m1->hardware->pos, m2->hardware->pos, i);
			for (int x=-3; x<=3; x++)
			    for (int y=-3; y<3; y++)
				state.accessible[(int)p.x+x][(int)p.y+y] = false;
		    }
	    }
}

void smartMove(AIObject* aiob, TPoint dest) {
    TPoint p = halfWayPX(aiob->hardware->pos, dest, state.params.look_ahead);
    p = aiob->software->correctDir(p);
    aiob->software->low_move(p);
}

void computeActions1() {
    FOREACH(state.workers, it)
	if (it->hardware->HW_TYPE == HW_WORKER1) {
	    AIObject* m = state.minerals->nearest(it->hardware->pos);
	    if (it->software->canGather(m)) {
		it->software->low_gather(m);
		it->software->min_dst = (int)state.myControlCenters->nearest(it->hardware->pos);
	    } else {
		smartMove(it, m->hardware->pos);
	    }
	} else {
	    AIObject* cc = state.myControlCenters->nearest(it->hardware->pos);
		it->software->low_return(cc);
		it->software->min_dst = (int)state.minerals->nearest(it->hardware->pos);
	    if (it->software->canReturn(cc)) {
	    } else {
		smartMove(it, cc->hardware->pos);
	    }
	}
    FOREACH(state.workers, it)
	it->software->low_commit();
}
