#ifndef Formation_H
#define Formation_H

#include "Hardware.H"
#include "UnitGroup.H"

class Formation : public UnitGroup {
    private:
	int nodesInC[MAX_MAP_DIST];
	int nodesInA[MAX_MAP_DIST][MAX_MAP_DIST];
	bool is_start[MAX_NODES];
	bool is_end[MAX_NODES];
	void redraw();
	inline bool blocked(int node);
    protected:
	bool is_blocked[MAX_NODES];
	int nc;
	int next_ok[MAX_NODES];
	int next_dest[MAX_UNITS];
	float values[MAX_NODES];
	float avg_dist;
	bool nb[8];
	virtual bool ignore(AIObject* aiob);
	virtual bool startFrom(int node);
	virtual bool endAt(int node);
	virtual float evalStart(int node);
	virtual float evalNext(int node);
	virtual float evalEnd(int node);
	virtual void setDirections();
    public:
	Formation();
	virtual ~Formation() {};
	void sync();
	virtual void commit();
};

#endif
