#ifndef L1_H
#define L1_H

#include "TPoint.H"
#include "Hardware.H"

// order types
#define LOW_IDLE	0
#define LOW_STOP	1
#define LOW_MOVE	2
#define LOW_ATTACK	3
#define LOW_GATHER	4
#define LOW_RETURN	5

#define MAX_WORKER_LOAD	10

using namespace std;

class Hardware;
class AIObject;

class L1 {				// low-level single-unit ai
    protected:
	Hardware* hardware;
	void stopNow();
	void moveNow(TPoint d);
	void attackNow(AIObject* t);
	void gatherNow(AIObject* aiob);
	void returnNow(AIObject* aiob);
    public:
	bool idle; // unused ?
	TPoint low_dest;		// direct move destination
	AIObject* low_target;		// direct attack target
	int low_order;			// current order type
	int load;
	L1(Hardware* h);
	~L1() {};
	bool canAttack(AIObject* t);	// iff low_attack can be called
	bool canGather(AIObject* m);
	bool canReturn(AIObject* cc);
	    // these orders are followed (?) when low_commit procedure is called
	void low_stop();		// stops the unit
	void low_move(TPoint d);	// move (in straight line) to point d
	void low_attack(AIObject* t);	// attack object t
	void low_gather(AIObject* m);	// gather mineral m
	void low_return(AIObject* cc);	// return resources ro control center cc
	    // only last acquired order is commited.
	void low_commit();		// commit last order
};

#endif
