#include <string>
#include <sstream>

#include "TPoint.H"

using namespace std;

TPoint::TPoint() {
    x = -2;
    y = -2;
}

TPoint::TPoint(int x, int y) {
    this->x = (float)x;
    this->y = (float)y;
}

TPoint::TPoint(float x, float y) {
    this->x = x;
    this->y = y;
}

string TPoint::toString() {
    stringstream ss;
    string str;
    ss << "Point(" << (int)x << "," << (int)y << ")";
    ss >> str;
    return str;
}

bool operator==(TPoint p1, TPoint p2) {
    return ((p1.x == p2.x) && (p1.y == p2.y));
}

bool operator!=(TPoint p1, TPoint p2) {
    return ((p1.x != p2.x) || (p1.y != p2.y));
}

TPoint operator+(TPoint p1, TPoint p2) {
    return TPoint(p1.x+p2.x, p1.y+p2.y);
}

TPoint operator-(TPoint p1, TPoint p2) {
    return TPoint(p1.x-p2.x, p1.y-p2.y);
}

TPoint operator*(TPoint p1, float m) {
    return TPoint(p1.x*m, p1.y*m);
}

TPoint operator/(TPoint p1, float m) {
    return TPoint(p1.x/m, p1.y/m);
}
