#ifndef UnitGroup_H
#define UnitGroup_H

#include <vector>

#include "GameObj.H"

#include "TPoint.H"
#include "Hardware.H"

#define FOREACHTYPEDFROM(begin, x, ittype, it) \
    for(__typeof(begin) it##0=(begin); it##0!=(x).end(); ++it##0) \
    for(int i##0=0; i##0<1; ++i##0) \
    for(ittype it=(ittype)(*it##0); i##0<1; ++i##0)

#define FOREACHTYPED(x, ittype, it) \
    FOREACHTYPEDFROM((x->v).begin(), x->v, ittype, it)

#define FOREACH(x, it) FOREACHTYPED(x, AIObject*, it)

using namespace std;

class AIObject;

class UnitGroup {			// set of units (game objects)
    private:
	float near_d[MAX_UNITS];
	AIObject* near_o[MAX_UNITS];
    public:
	vector<AIObject*> v;		// set of units
	int size;			// units count in group
	int max_life;			// max. total life of units
	UnitGroup();
	~UnitGroup() {};
	void addUnit(AIObject* aiob);
	void removeUnit(GameObj* gob);
	void addGroup(UnitGroup* ug);
	int totalLife(int when);	// current total life of units in group
	int maxLife();			// max. life of units in group
	AIObject* nearest(TPoint p, int n = 0);	// n-th nearest unit from group (from point p)
	float nearest(int node, int n = 0);	// distance to n-th nearest unit (from node n)
	float distTo(UnitGroup* g);
	int busy();			// how many units in group are not (software->idle)
	AIObject* any();		// random unit from group
	TPoint middle();		// average position of units in group
	int outOfSync();		// computes how many units are not ready
	void refresh();			// remove dead units from group
	void update();			// calls software->update() for each unit
};

#endif
