#include "Common.H"
#include "AIState.H"
#include "AIGUI.H"
#include "UnitGroup.H"
#include "Formation.H"
#include "WorkerFormation.H"

WorkerFormation::WorkerFormation() : Formation() {
    return_res = false;
    last_g = -1;
    last_w = 0;
}

bool WorkerFormation::startFrom(int node) {
    float d = 0;
    float r = 0;
    if (return_res) {
	AIObject* cc = state.myControlCenters->any();
	TPoint c = cc->hardware->pos;
	TPoint p = NODEPOS(node);
	r = any()->software->GATHER_RANGE;
	return (MAX(ABS(c.x-p.x), ABS(c.y-p.y)) < cc->hardware->SIZE * 0.8 + r);
    } else {
	if (state.minerals->size == 0)
	    ERR("No minerals on map");
	d = state.minerals->nearest(node);
	r = any()->software->GATHER_RANGE;
	return (d < r);
    }
}

void WorkerFormation::commit() {
    Formation::commit();
    int w1 = 0;
    int w2 = 0;
    FOREACH(this, it)
	if (it->hardware->HW_TYPE == HW_WORKER1) {
	    w1++;
	} else {
	    w2++;
	}
    DRAWLINE(50, 20, 100, 20, ClBlack);
    if (return_res) {
	DRAWLINE(50, 20, 70, 10, ClBlack);
	DRAWLINE(50, 20, 70, 30, ClBlack);
	if (last_g == -1) {
	    if (w1 > last_w) {
		last_g = state.game_time;
		last_w = w1;
	    }
	} else {
	    if (w1 > last_w) {
		last_g = state.game_time;
		last_w = w1;
		AI_GUI->circle(20, 20, 15, ClDarkGreen, true);
		c_info << "resources++" << endl;
	    }
	    if (state.game_time - last_g > 50) {
		return_res = false;
		last_g = -1;
		last_w = w2;
		FOREACH(this, it)
		    it->software->ignore = false;
	    }
	}
    } else {
	DRAWLINE(100, 20, 80, 10, ClBlack);
	DRAWLINE(100, 20, 80, 30, ClBlack);
	if (last_g == -1) {
	    if (w2 > last_w) {
		last_g = state.game_time;
		last_w = w2;
	    }
	} else {
	    if (w2 > last_w) {
		last_g = state.game_time;
		last_w = w2;
		AI_GUI->circle(20, 20, 15, ClDarkGreen, true);
		c_info << "minerals--" << endl;
	    }
	    if (state.game_time - last_g > 50) {
		return_res = true;
		last_g = -1;
		last_w = w1;
		FOREACH(this, it)
		    it->software->ignore = false;
	    }
	}
    }
}
