// $Id: Net_DBTypes.C,v 1.1 2005/08/23 21:24:53 hakman Exp $

/** (c) Michael Buro 2003, mburo@cs.ualberta.ca, licensed under the GPL */

#include "Net_DBTypes.H"
using namespace std;

//----------------------------------- DB_Player --------------------------------------
DB_Player::DB_Player(string name_, string pass_, Level level_)
{
  name  = name_;
  pass  = pass_;
  level = level_;
  rating = 0;
  loadGood = true;
}

DB_Player::DB_Player(string name_) { name  = name_; }

DB_Player::~DB_Player() {}

string DB_Player::getKey() const { return name; }

string DB_Player::getData() const
{
  stringstream ss;

  ss <<  pass       << " ";
  ss <<  (int)level << " ";
  ss <<  rating     << " ";
  
  FORALL (buddyList, i) ss <<  " " << *i;

  return ss.str();
}

void DB_Player::addBuddy(const string& name){
   FORALL(buddyList, i){
     if(*i == name){
       return;
     }
   }
   buddyList.push_back(name);
}

void DB_Player::remBuddy(const string& name)
{
  FORALL (buddyList, i) {
    if (*i == name){
      buddyList.erase(i);
      break;
    }
  }
}

void DB_Player::addNotify(const string& name){
   FORALL(notifyList, i){
     if(*i == name){
       return;
     }
   }
   notifyList.push_back(name);
}

void DB_Player::remNotify(const string& name)
{
  FORALL (notifyList, i) {
    if (*i == name){
      notifyList.erase(i);
      break;
    }
  }
}

void DB_Player::setData(const string& data)
{
  stringstream ss(data);
  string temp;

  ss >> pass;
  int l;
  ss >> l;
  level = (Level)l;
  ss >> rating;

  buddyList.clear();
  notifyList.clear();

  while (ss >> temp && temp != "|") { buddyList.push_back(temp); }
  while (ss >> temp) { notifyList.push_back(temp); }
  
  loadGood = ss.good(); // checks if no error flas have been set
}






  
//-------------------------------- class DB_Worker ------------------------------------
DB_Worker::DB_Worker(const string& name_, const string& pass_)
{
  name = name_;
  pass = pass_;
  rating = 0;
  loadGood = true;
}

DB_Worker::~DB_Worker(){}

string DB_Worker::getKey() const { return name; }
  
string DB_Worker::getData() const
{
  stringstream ss;
  ss << name << " " << pass << " "<< rating;
  return ss.str();
}

void DB_Worker::setData(const string& data)
{
  stringstream ss(data);
  ss >> pass;
  ss >> rating;
  // fixme: stream error check?!
}
