// $Id: Net_Worker.H,v 1.5 2005/09/06 05:50:48 orts_furtak Exp $

// This is an ORTS file (c) Tu Hoang, licensed under the GPL

/*
 * ====================================================================================
 * 
 *        Filename:  Net_Worker.H
 * 
 *     Description:  Worker class for ORTS
 * 
 *         Version:  1.0
 *         Created:  05/25/04 15:22:49 MDT
 *        Revision:  none
 *        Compiler:  gcc
 * 
 *          Author:  Tu Hoang 
 * 
 * ====================================================================================
 */

#ifndef NET_WORKER_H
#define NET_WORKER_H

#include "Server.H"

#include "Net_Message.H"
#include "Net_GGSClient.H"
#include "Global.H"
#include "Net_Protocol.H"
#include "EventHandler.H"
#include "ShutDown.H"

class Net_Worker : public EventHandler
{

public:
	
  // ====================  LIFECYCLE   ========================================= 

  std::string user_name;
  std::string password;
  std::string servicename;

  Net_Worker(const std::string &world_);
  virtual ~Net_Worker();
  
  // ====================  OPERATORS   ========================================= 
  sint4 run();
  // ====================  OPERATIONS  ========================================= 

protected:

  std::string world;
  //  GUI *gui;
  
  Net_GGSClient* client;
  
  /**
     skips all messages until the expected message is received. For a maximum
     of maxSpin messages
  */
  bool waitForResponse(Message_Base& expected);

  bool handle_event(const Event&);
};      // ----------  end of class  Net_Worker  ---------- 

#endif
