#include "GAITank.H"

using namespace std;

	GAITank::GAITank(GameObj* tankie, int vehicleID)
	{
		tank = tankie;
		ID = vehicleID;
		pathfinder = new aStarLibrary();
		pathfinder->InitializePathfinder();
		firstTime = 1;
		attacking = false;
	}

	void GAITank::init() {
		from = getTileCoor(*tank->sod.x,*tank->sod.y);
		pathfinder->walkability [from.x][from.y] = pathfinder->unwalkable;
		UnwalkableTile.x = from.x; UnwalkableTile.y = from.y;
		temporaryGoal.x = -1;
		temporaryGoal.y = -1;
		tempGoalSet = false;
		standStill = 0;
	}

	bool GAITank::act(const Game& game)
	{
		if ( firstTime ) {
			firstTime = 0;
		}
		if ( lastPosition.x == *tank->sod.x && lastPosition.y == *tank->sod.y ) {
			pathfinder->pathStatus[1] = pathfinder->FindPath (1 ,*tank->sod.x, *tank->sod.y, 100, 100);			
			pathfinder->walkability [from.x][from.y] = pathfinder->walkable;
			int path_out = pathfinder->ReadPath(1,*tank->sod.x, *tank->sod.y,1);
			ScalarPoint t;
			t.x = pathfinder->xPath[1];
			t.y = pathfinder->yPath[1];
	
			Vector<sint4> params;
			params.push_back(t.x);
			params.push_back(t.y);
			params.push_back(*tank->sod.max_speed);
			tank->set_action("move", params);
			ScalarPoint to = getTileCoor(t.x,t.y);
			pathfinder->walkability [to.x][to.y] = pathfinder->unwalkable;
			from = to;
		}
		lastPosition.x = *tank->sod.x;
		lastPosition.y = *tank->sod.y;

		return true;
	}

	int GAITank::getID()
	{
		return ID;
	}

	int GAITank::TileWalkable(const GameTile &tile)
	{
		//const GameTile &tile = map(x,y);
		sint4 hNW, hNE, hSE, hSW;
		Tile::Split split;
		// get corner heights and split type
		tile.get_topo(hNW, hNE, hSE, hSW, split);
		if (hNW > 0 || hNE > 0 || hSE > 0 || hSW > 0 || split > 0)
			return pathfinder->unwalkable;
		else 
			return pathfinder->walkable;
	}

	ScalarPoint GAITank::getTileCoor(int x, int y)
	{
		ScalarPoint bla;
		bla.x = x/16;
		bla.y = y/16;
		return bla;
	}

	ScalarPoint GAITank::getPosition() {
		ScalarPoint position;
		position.x = *tank->sod.x;
		position.y = *tank->sod.y; 
		return position;
	}

	void GAITank::move(int x, int y) {
		ScalarPoint t;
		t.x = x;
		t.y = y;
		ScalarPoint t2 = getTileCoor(t.x,t.y);
		Vector<sint4> params;
		params.push_back(t.x);
		params.push_back(t.y);
		params.push_back(*tank->sod.max_speed);
		pathfinder->walkability [from.x][from.y] = pathfinder->walkable;
		WalkableTile.x = from.x; WalkableTile.y = from.y;
		pathfinder->walkability [t2.x][t2.y] = pathfinder->unwalkable;
		UnwalkableTile.x = t2.x; UnwalkableTile.y = t2.y;
		tank->set_action("move", params);
	}

	void GAITank::moveSelf(int x, int y) {
		attacking = false;
		if ( lastPosition.x == *tank->sod.x && lastPosition.y == *tank->sod.y ) {
			//pathfinder->EndPathfinder();
			//pathfinder = new aStarLibrary();
			//pathfinder->InitializePathfinder();
			pathfinder->walkability [from.x][from.y] = pathfinder->walkable;
			WalkableTile.x = from.x; WalkableTile.y = from.y;
			pathfinder->pathStatus[1] = pathfinder->FindPath (1 ,*tank->sod.x, *tank->sod.y, x, y);
			ScalarPoint t;
			if ( pathfinder->pathStatus[1] < 0 ) {
				t.x = x;
				t.y = y;
			} else {
				int path_out = pathfinder->ReadPath(1,*tank->sod.x, *tank->sod.y,1);
				t.x = pathfinder->xPath[1];
				t.y = pathfinder->yPath[1];
			}	
			Vector<sint4> params;
			params.push_back(t.x);
			params.push_back(t.y);
			params.push_back(*tank->sod.max_speed);
			tank->set_action("move", params);
			ScalarPoint to = getTileCoor(t.x,t.y);
			pathfinder->walkability [to.x][to.y] = pathfinder->unwalkable;
			UnwalkableTile.x = to.x; UnwalkableTile.y = to.y;
			from = to;
		}
		lastPosition.x = *tank->sod.x;
		lastPosition.y = *tank->sod.y;
	}
	
	void GAITank::moveSelfWOPathfinding(int x, int y, int speed) {
		if ( lastPosition.x == *tank->sod.x && lastPosition.y == *tank->sod.y ) {
			pathfinder->walkability [from.x][from.y] = pathfinder->walkable;
			WalkableTile.x = from.x; WalkableTile.y = from.y;
			ScalarPoint t;
			t.x = x;
			t.y = y;
			Vector<sint4> params;
			params.push_back(t.x);
			params.push_back(t.y);
			params.push_back((*tank->sod.max_speed)*speed);
			tank->set_action("move", params);
			ScalarPoint to = getTileCoor(t.x,t.y);
			pathfinder->walkability [to.x][to.y] = pathfinder->unwalkable;
			UnwalkableTile.x = to.x; UnwalkableTile.y = to.y;
			from = to;
		}
		lastPosition.x = *tank->sod.x;
		lastPosition.y = *tank->sod.y;
	}

	void GAITank::setGoal(int x, int y) {
		goaly.x = x;
		goaly.y = y;
	}

	bool GAITank::goalReached() {
		if ( abs(goaly.x - *tank->sod.x) <= 1 && abs(goaly.y - *tank->sod.y) <= 1 ) return true;
		else return false;
	}

	bool GAITank::temporaryGoalReached() {
		if ( abs(temporaryGoal.x - *tank->sod.x) <= 1 && abs(temporaryGoal.y - *tank->sod.y) <= 1 ) return true;
		else return false;
	}

	void GAITank::setFormation(int x, int y) {
		formation.x = x;
		formation.y = y;
	}

	ScalarPoint GAITank::getFormation() {
		return formation;
	}

	bool GAITank::isAttacking() {
		return attacking;
	}

	GameObj* GAITank::weakestInRange(const Game& game, int enemyID, double multiplier) {
		ScriptObj *weapon = tank->component("weapon");
		sintptr *prange = weapon->get_int_ptr("max_ground_range");
		const sint4 range2 = (multiplier * *prange) * (multiplier * *prange);
		int weakest = 999999;
		// check for targets (could be done much faster)
		const Game::ObjCont &opp_objs = game.get_objs(enemyID);
		GameObj *target = 0;
		FORALL (opp_objs, it) {
			GameObj *gob2 = (*it)->get_GameObj();
			if (gob2 && gob2->sod.in_game && gob2->bp_name() == "tank" && *gob2->sod.x >= 0 && !gob2->is_dead()) {
				real8 d2 =
					square(real8(*tank->sod.x - *gob2->sod.x)) +
					square(real8(*tank->sod.y - *gob2->sod.y));
				const sintptr *health = gob2->get_int_ptr("hp");
	      			if (d2 <= range2 && *health < weakest && *health >= 0) {
					// target within range
					target = gob2;
					weakest = *health;
	    			}
	  		}
		}
		if (!target) attacking = false;
		return target;
	}
	void GAITank::attackControlInRange(const Game& game, int enemyID) {
		// check for targets (could be done much faster)
		ScriptObj *weapon = tank->component("weapon");
		sintptr *prange = weapon->get_int_ptr("max_ground_range");
		const sint4 range2 = *prange * *prange;
		const Game::ObjCont &opp_objs = game.get_objs(enemyID);
		GameObj *target = 0;
		GameObj *closestControl = 0;
		real8 distance = 9999999;
		FORALL (opp_objs, it) {
			GameObj *gob = (*it)->get_GameObj();
			if (gob && gob->bp_name() == "controlCenter" && *gob->sod.x1 > 0 && gob->sod.in_game && !gob->is_dead()){
				real8 d2 =
					square(real8(*tank->sod.x - *gob->sod.x1 - 32)) +
					square(real8(*tank->sod.y - *gob->sod.y1 - 32));
				if (d2 <= range2) {
					// target within range
					target = gob;
//					cout << "Setting ControlCenter [" << *gob->sod.x1 << "," << *gob->sod.y1 << "] as target" << endl;
	    			}
				else if (d2 < distance){
					closestControl = gob;
					distance = d2;
				}
	  		}
		}
		if (target) {
			attacking = true;
			cout << "shooting at controlcenter at [" <<*target->sod.x1 << "," << *target->sod.y1<<"] with health " << *target->get_int_ptr("hp") <<endl;
			Vector<sint4> args;
			args.push_back(game.get_cplayer_info().get_id(target));
			tank->component("weapon")->set_action("attack", args);
		}
		/*else{ 
			moveSelf(*closestControl->sod.x1 + 32, *closestControl->sod.y1 + 32);
			setGoal(*closestControl->sod.x1 + 32, *closestControl->sod.y1 + 32);
			attacking = false;
			cout << "moving to closest control center" << endl;
		}*/
	}

	void GAITank::attackWeakestInRange(const Game& game, GameObj* target) {
	/*	ScriptObj *weapon = tank->component("weapon");
		sint4 *prange = weapon->get_int_ptr("max_ground_range");
		const sint4 range2 = *prange * *prange;
		int weakest = 999999;
		// check for targets (could be done much faster)
		const Game::ObjCont &opp_objs = game.get_objs(enemyID);
		GameObj *target = 0;
		FORALL (opp_objs, it) {
			GameObj *gob2 = (*it)->get_GameObj();
			if (gob2 && gob2->sod.in_game && *gob2->sod.x >= 0 && !gob2->is_dead()) {
				real8 d2 =
					square(real8(*tank->sod.x - *gob2->sod.x)) +
					square(real8(*tank->sod.y - *gob2->sod.y));
				const sint4* health = gob2->get_const_int_ptr("hp");
	      			if (d2 <= range2 && *health < weakest && *health >= 0) {
					// target within range
					target = gob2;
					weakest = *health;
	    			}
	  		}
		}*/
      		if (target) {
			attacking = true;
cout << "shooting at target with health " << *target->get_int_ptr("hp") << " at [" <<*target->sod.x << "," << *target->sod.y<<"]"<<endl;
			Vector<sint4> args;
			args.push_back(game.get_cplayer_info().get_id(target));
			tank->component("weapon")->set_action("attack", args);
		}
	}
