#ifndef Minimap_H
#define Minimap_H

// $Id: Minimap.H,v 1.1 2006/06/27 02:32:30 orts_mburo Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "GfxGlobal.H"

class GameObj;
class Game;

class Minimap {
 
public:

  Game *game;

  uint4 vtexture_mode;
  sint4 map_width;
  sint4 map_height;
  sint4 map_tiles;
  sint4 texture_width;
  sint4 texture_height;
  sint4 texture_pixels;
  
  uint4 disp_width;
  sint4 tile_points;
  bool changed;

  Vector<Col3> height_colors;
  Vector<Col3> ground_colors;
  Vector<uint1> visible_colors;
  
  GLuint color_texture_id;
  GLuint visible_texture_id;

  uint1 *explored;

  // OpenGL color values
  GLubyte *color_texture;
  GLubyte *visible_texture;

  void initialize_colors();
  uint4 col2uint4(const Col3 &color);
  bool has_changed(); // returns true iff minimap has changed since last call to changed

public:
  
  Minimap(Game* g);
  ~Minimap();

  GLuint get_color_tex_id()  { return color_texture_id;  }
  GLuint get_visible_tex_id() { return visible_texture_id; }
  real4 scale_w, scale_h;

  bool update_texture(); // updates all changes on texture
  
  void new_tile(uint4 x, uint4 y, uint1 height, uint1 ground);
};

#endif
