/** @file mainpage.cpp
    Main page for <a href="http://www.doxygen.org/">Doxygen</a>.
*/    

/** @mainpage Pathfinding library documentation
    
@section Overview

The pathfinding library is a testbed for running experiments
with pathfinding algorithms with emphasis on environments
found in computer games.

By using pure abstract base classes for the search algorithm
(PathFind::Search) and the search environment (PathFind::Environment)
it is possible to reuse parts of the existing code when experimenting
with new algorithms or new environments.

At present, the following algorithms and environments are implemented:

Search algorithms:

- PathFind::AStar
- PathFind::IDAStar
- PathFind::FringeSearch

Search environments:

- PathFind::Tiling

In addition, the library provides utility classes:

- PathFind::Statistics, PathFind::StatisticsCollection
  for collecting search statistics,
- PathFind::SearchUtils for running search experiments,
- PathFind::Graph for implementing graphs.

@section Platforms

The current version of the library is developed on Linux using GCC.
It uses only standard C++, so it should be easily portable to other
platforms.

@section Authors

Markus Enzenberger \<emarkus@cs.ualberta.ca\> <br>
Yngvi Bjornsson \<yngvi@cs.ualberta.ca\> <br>

Contributions from:

Adi Botea \<adib@cs.ualberta.ca\> <br>

@section Copying

This software is copyrighted by the
<a href="http://www.cs.ualberta.ca">Computing Science Department</a> of the
<a href="http://www.ualberta.ca">University of Alberta</a>.
It is distributed under the
<a href="http://www.gnu.org/copyleft/gpl.html">
General Public License</a> version 2 or (at your option) any later version.
See the file COPYING for details.

*/
